package org.gcube.service.idm.test;

import org.gcube.idm.common.is.IsServerConfig;
import org.gcube.service.idm.keycloack.KkClientFactory;
import org.gcube.service.idm.liferay.LiferayClientFactory;
import org.gcube.smartgears.ContextProvider;
import org.gcube.smartgears.configuration.container.ContainerConfiguration;
import org.gcube.smartgears.context.application.ApplicationContext;
import org.gcube.smartgears.context.container.ContainerContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import jakarta.ws.rs.NotFoundException;

public class IsTest extends ServiceContextTest {
	private static final Logger logger = LoggerFactory.getLogger(IsTest.class);

	// @Test
	// @Ignore
	public void checkContext() throws Exception {
		ApplicationContext ctx = ContextProvider.get();
		ContainerContext container = ctx.container();
		ContainerConfiguration configuration = container.configuration();

		String infra_context = "/" + configuration.infrastructure();
		logger.debug("Testing Keycloak service IS config %s", infra_context  );
	}

	// @Test
	public void testIsKeycloak() throws Exception {

		logger.debug("Testing Keycloak service IS config");
		IsServerConfig config = null;

		KkClientFactory client = KkClientFactory.getSingleton();
		org.junit.Assert.assertNotNull(client);
		client.setSecret(ServiceContextTest.current_secret);

		try {
			config = client.fetchIsConfig(ServiceContextTest.current_secret);
		} catch (NotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		org.junit.Assert.assertNotNull(config);

		logger.debug("fetched Keycloak service IS config ");
	}

	//@Test
	public void testIsLiferay() {
		logger.debug("Testing Liferay service IS config");
		IsServerConfig config = null;

		LiferayClientFactory client = LiferayClientFactory.getSingleton();
		org.junit.Assert.assertNotNull(client);

		try {
			client.setSecret(ServiceContextTest.current_secret);
			config = client.fetchIsConfig();
		} catch (NotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		org.junit.Assert.assertNotNull(config);

		logger.debug("fetched Liferay service IS config ");
	}
}
